////////////////////////////////////////////////////////////////////////////////
//                            CFireTestDlg
// File name: FireTestDlg.h
// Author: Sergey Krivulya (Ce p) - KSerg
// e-mail: Sergey_Krivulya@UkrPost.Net
// Date: 21 07 2004
////////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_FIRETESTDLG_H__487DB126_8B49_11D8_99CA_DB9306728247__INCLUDED_)
#define AFX_FIRETESTDLG_H__487DB126_8B49_11D8_99CA_DB9306728247__INCLUDED_

#include "Bitmap32.h"
#include "Fire.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CFireTestDlg dialog

class CFireTestDlg : public CDialog
{
// Construction
public:
	CFireTestDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CFireTestDlg)
	enum { IDD = IDD_FIRETEST_DIALOG };
	CSpinButtonCtrl	m_SpinDirection;
	CButton	m_RadioBtnDirection;
	CButton	m_BtnBmpMasked;
	CButton	m_BtnBmpMask;
	CButton	m_BtnBmpOriginal;
	CButton	m_CheckTransparent;
	CSpinButtonCtrl	m_SpinTransparent;
	CButton	m_CheckFlameOnly;
	CSpinButtonCtrl	m_SpinGradientStep;
	CButton	m_CheckRestart;
	CSpinButtonCtrl	m_SpinGradientPrecision;
	CStatic	m_StaticGradientBMP;
	CSliderCtrl	m_SliderGradient;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CFireTestDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CFireTestDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnButton_LoadBmpOriginal();
	afx_msg void OnPaint();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnChange_EditGradientPrecision();
	afx_msg void OnClicked_StaticGradientBitmap();
	afx_msg void OnButton_LoadBmpMask();
	afx_msg void OnCheck_RestartChanges();
	afx_msg void OnChange_EditGradientStep();
	afx_msg void OnChange_EditTransparent();
	afx_msg void OnCheck_FireOnly();
	afx_msg void OnCheck_Transparent();
	afx_msg void OnChange_EditDirection();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
   void ApplyChanges(BOOL bRestart);
   CString m_strFileBmpOriginal;
   CString m_strFileBmpMask;
   float m_fPercent;
   COLORREF m_colorHot, m_colorCold, m_colorBk;
   CFire m_Fire;
   bool m_bRestart;
   CString m_strCaption;

   WNDPROC defWndProc_StaticGradientBMP; //  -     IDC_STATIC_GRADIENT_BITMAP
   static LRESULT CALLBACK newWndProc_StaticGradientBMP(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam); //  -      IDC_STATIC_GRADIENT_BITMAP

   void CFireTestDlg::DrawFlameOrMask(HDC hDC);
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_FIRETESTDLG_H__487DB126_8B49_11D8_99CA_DB9306728247__INCLUDED_)
