////////////////////////////////////////////////////////////////////////////////
// File name: CommonLib.h
// Author: Sergey Krivulya (Ce p) - KSerg (SeregaLBN)
// e-mail: Sergey_Krivulya@UkrPost.Net
// ICQ: 72099167
// WWW page: http://kserg77.narod.ru/CommonLib.html
// Date: 2007 06 14
//
// Description:   .
////////////////////////////////////////////////////////////////////////////////

#ifndef __FILE__KSERG_COMMON_LIB__
#define __FILE__KSERG_COMMON_LIB__

#if _MSC_VER > 1000
   #pragma once
#endif // _MSC_VER > 1000

#if !defined(__AFX_H__) && !defined(_WTL_USE_CSTRING)
   #include <Windows.h>
   #include "CStringKS.h"
#endif
#include <WindowsX.h>
#include <ShlObj.h>
#include <CommDlg.h>

#define chDIMOF(Array) (sizeof(Array) / sizeof(Array[0])) //    

#ifndef MAKELONGLONG
   #define MAKELONGLONG(dwLow, dwHigh)  ((LONGLONG(DWORD(dwLow)) & 0x00000000FFFFFFFF) | ((LONGLONG(DWORD(dwHigh)) & 0x00000000FFFFFFFF) << 32))
#endif

inline BOOL InitializeCriticalSectionEx(CRITICAL_SECTION &cs, DWORD dwSpinCount = 4000);

CString Base64_Code  (IN LPCTSTR szIn); // Base 64 
CString Base64_Decode(IN LPCTSTR szIn); // Base 64 
BOOL Base64_Code(
   IN BYTE const *pData,     //    - ,   
   IN DWORD dwSize,
   OUT LPTSTR szCodeData,    //   -  
   IN OUT DWORD &dwLenInChar // length in TCHAR (if szCodeData == NULL then return length include EOL)
);
BOOL Base64_Decode(
   IN LPCTSTR szIn,     //    -  
   IN int iLenIn,       //   .  == -1,    ...
   OUT BYTE *pData,     //   -  
   IN OUT DWORD &dwSize // IN -  ; OUT -   
);                      //  dwSize==0 -    

struct POINTEX: public POINT {
   POINTEX()                 {x=      y=0   ;}
   POINTEX(const POINT &p)   {x=p. x; y=p. y;}
   POINTEX(const SIZE  &p)   {x=p.cx; y=p.cy;}
   POINTEX(LONG nx, LONG ny) {x=  nx; y=  ny;}
   POINTEX& operator+= (const POINT &a) {x+=a.x; y+=a.y; return *this;}
   POINTEX& operator-= (const POINT &a) {x-=a.x; y-=a.y; return *this;}
   POINTEX& operator*= (LONG val      ) {x*=val; y*=val; return *this;}
   POINTEX& operator/= (LONG val      ) {x/=val; y/=val; return *this;}
   operator SIZE() const {SIZE result =   {x,y}; return result;}
   operator RECT() const {RECT rect = {0,0,x,y}; return rect;}
};

inline POINT operator*  (LONG  val     , const POINT &a) {return POINTEX(a.x*val, a.y*val);}
inline POINT operator*  (const POINT &a, LONG  val     ) {return POINTEX(a.x*val, a.y*val);}
inline POINT operator/  (const POINT &a, LONG  val     ) {return POINTEX(a.x/val, a.y/val);}
inline POINT operator+  (const POINT &a, const POINT &b) {return POINTEX(a.x+b.x, a.y+b.y);}
inline POINT operator-  (const POINT &a, const POINT &b) {return POINTEX(a.x-b.x, a.y-b.y);}
inline bool  operator== (const POINT &a, const POINT &b) {return (a.x==b.x && a.y==b.y);}
inline bool  operator!= (const POINT &a, const POINT &b) {return (a.x!=b.x || a.y!=b.y);}

struct SIZEEX: public SIZE {
   SIZEEX()                 {cx=      cy=0   ;}
   SIZEEX(const SIZE  &p)   {cx=p.cx; cy=p.cy;}
   SIZEEX(const POINT &p)   {cx=p. x; cy=p. y;}
   SIZEEX(const RECT  &p)   {cx=p.right - p.left; cy=p.bottom-p.top;}
   SIZEEX(LONG nX, LONG nY) {cx=nX  ; cy=nY  ;}
   SIZEEX& operator+= (const SIZE &a) {cx+=a.cx; cy+=a.cy; return *this;}
   SIZEEX& operator-= (const SIZE &a) {cx-=a.cx; cy-=a.cy; return *this;}
   SIZEEX& operator*= (LONG val     ) {cx*=val ; cy*=val ; return *this;}
   SIZEEX& operator/= (LONG val     ) {cx/=val ; cy/=val ; return *this;}
   operator POINT() const {POINT result =   {cx,cy}; return result;}
   operator RECT () const {RECT  rect = {0,0,cx,cy}; return rect;}
};

inline SIZE operator*  (LONG  val    , const SIZE &a) {return SIZEEX(a.cx*val , a.cy*val );}
inline SIZE operator*  (const SIZE &a, LONG  val    ) {return SIZEEX(a.cx*val , a.cy*val );}
inline SIZE operator/  (const SIZE &a, LONG  val    ) {return SIZEEX(a.cx/val , a.cy/val );}
inline SIZE operator+  (const SIZE &a, const SIZE &b) {return SIZEEX(a.cx+b.cx, a.cy+b.cy);}
inline SIZE operator-  (const SIZE &a, const SIZE &b) {return SIZEEX(a.cx-b.cx, a.cy-b.cy);}
inline bool operator== (const SIZE &a, const SIZE &b) {return (a.cx==b.cx && a.cy==b.cy);}
inline bool operator!= (const SIZE &a, const SIZE &b) {return (a.cx!=b.cx || a.cy!=b.cy);}

struct COORDEX: public COORD {
   COORDEX()                   {X=     Y=0  ;}
   COORDEX(const COORD& p)     {X=p.X; Y=p.Y;}
   COORDEX(SHORT nX, SHORT nY) {X= nX; Y= nY;}
   COORDEX& operator+= (const COORD &a) {X+=a.X; Y+=a.Y; return *this;}
   COORDEX& operator-= (const COORD &a) {X-=a.X; Y-=a.Y; return *this;}
   COORDEX& operator*= (SHORT val     ) {X*=val; Y*=val; return *this;}
   COORDEX& operator/= (SHORT val     ) {X/=val; Y/=val; return *this;}
};

inline COORD operator*  (SHORT val     , const COORD &a) {return COORDEX(a.X*val, a.Y*val);}
inline COORD operator*  (const COORD &a, SHORT val     ) {return COORDEX(a.X*val, a.Y*val);}
inline COORD operator/  (const COORD &a, SHORT val     ) {return COORDEX(a.X/val, a.Y/val);}
inline COORD operator+  (const COORD &a, const COORD &b) {return COORDEX(a.X+b.X, a.Y+b.Y);}
inline COORD operator-  (const COORD &a, const COORD &b) {return COORDEX(a.X-b.X, a.Y-b.Y);}
inline bool  operator== (const COORD &a, const COORD &b) {return (a.X==b.X && a.Y==b.Y);}
inline bool  operator!= (const COORD &a, const COORD &b) {return (a.X!=b.X || a.Y!=b.Y);}

struct RECTEX: public RECT {
    //    X / Y (   )
   RECTEX& moveX(LONG x)         {left += x; right += x; return *this;}
   RECTEX& moveY(LONG y)         {top  += y; bottom+= y; return *this;}
   RECTEX& move (LONG x, LONG y) {moveX(x); return moveY(y);}
   RECTEX& move (const SIZE  &p) {return move(p.cx, p.cy);}

   //   (   )
   RECTEX& alignLeft  (LONG l)         {right  += l-left  ; left   = l; return *this;} //          
   RECTEX& alignRight (LONG r)         {left   += r-right ; right  = r; return *this;} //         
   RECTEX& alignTop   (LONG t)         {bottom += t-top   ; top    = t; return *this;} //        
   RECTEX& alignBottom(LONG b)         {top    += b-bottom; bottom = b; return *this;} //         
   RECTEX& alignLT    (LONG x, LONG y) {alignLeft (x); return alignTop   (y);}
   RECTEX& alignRT    (LONG x, LONG y) {alignRight(x); return alignTop   (y);}
   RECTEX& alignLB    (LONG x, LONG y) {alignLeft (x); return alignBottom(y);}
   RECTEX& alignRB    (LONG x, LONG y) {alignRight(x); return alignBottom(y);}
   RECTEX& alignLT    (const POINT &p) {return alignLT(p.x, p.y);}
   RECTEX& alignRT    (const POINT &p) {return alignRT(p.x, p.y);}
   RECTEX& alignLB    (const POINT &p) {return alignLB(p.x, p.y);}
   RECTEX& alignRB    (const POINT &p) {return alignRB(p.x, p.y);}

   RECTEX& alignCenter(const POINT &c) {return move(SIZEEX(c-center()));}        //       
   RECTEX& alignCenter(const RECT  &r) {return alignCenter(RECTEX(r).center());} //       
   RECTEX& alignCenter(LONG x, LONG y) {return alignCenter(POINTEX(x,y));}       //      

   // get/set metods
   LONG    width () const {return right -left;}
   LONG    height() const {return bottom-top ;}
   RECTEX& width (LONG w) {right  = left+w; return *this;}
   RECTEX& height(LONG h) {bottom = top +h; return *this;}

   POINTEX pointLT() const           {return POINTEX(left , top   );}
   POINTEX pointRT() const           {return POINTEX(right, top   );}
   POINTEX pointLB() const           {return POINTEX(left , bottom);}
   POINTEX pointRB() const           {return POINTEX(right, bottom);}
   RECTEX& pointLT(LONG x, LONG y)   {left  = x; top    = y; return *this;}
   RECTEX& pointRT(LONG x, LONG y)   {right = x; top    = y; return *this;}
   RECTEX& pointLB(LONG x, LONG y)   {left  = x; bottom = y; return *this;}
   RECTEX& pointRB(LONG x, LONG y)   {right = x; bottom = y; return *this;}
   RECTEX& pointLT(const POINT& pLT) {return pointLT(pLT.x, pLT.y);}
   RECTEX& pointRT(const POINT& pRT) {return pointRT(pRT.x, pRT.y);}
   RECTEX& pointLB(const POINT& pLB) {return pointLB(pLB.x, pLB.y);}
   RECTEX& pointRB(const POINT& pRB) {return pointRB(pRB.x, pRB.y);}

   POINTEX center()const          {return POINTEX(left+(width()>>1), top+(height()>>1));}
   RECTEX& center( const POINT&c) {return alignCenter( c );} //       
   RECTEX& center( const RECT &r) {return alignCenter( r );} //       
   RECTEX& center(LONG x, LONG y) {return alignCenter(x,y);} //      
   SIZEEX  size  ()const          {return SIZEEX(width(), height());}
   RECTEX& size  ( const SIZE &s) {width(s.cx); return height(s.cy);}

   operator SIZE  () {return size();}
   operator SIZEEX() {return size();}

   // constructors
   RECTEX(const POINT &pLT, const POINT pRB) {left=pLT.x  ; top=pLT.y ; right=pRB.x   ; bottom=pRB.y   ;}
   RECTEX(const RECT &r)                     {left=r.left ; top=r.top ; right=r.right ; bottom=r.bottom;}
   RECTEX(LONG l, LONG t, LONG r, LONG b)    {left=l      ; top=t     ; right=r       ; bottom=b       ;}
   RECTEX(const SIZE &size)                  {left=         top=0     ; right=size.cx ; bottom=size.cy ;}
   RECTEX(LONG width, LONG height)           {left=         top=0     ; right=width   ; bottom=height  ;}
   RECTEX()                                  {left=         top=        right=          bottom=0       ;}
};

inline bool operator== (const RECT &a, const RECT &b) {return (a.left==b.left && a.top==b.top && a.right==b.right && a.bottom==b.bottom);}
inline bool operator!= (const RECT &a, const RECT &b) {return (a.left!=b.left || a.top!=b.top || a.right!=b.right || a.bottom!=b.bottom);}

inline long  toLong (float f); //     ftol  CRT
inline int   toInt  (float f);
inline float toFloat(long  l);
inline float toFloat(int   i);

inline RECTEX FindInnerRect (const SIZE  &sizeInner, const SIZE &sizeOutward);
inline RECTEX FindInnerRect (const RECT  &rectInner, const RECT &rectOutward);
inline BOOL   PointInRect   (const POINT &point, const RECT &rect   ); //   ?
inline BOOL   IntersectRect (const RECT  &rect1, const RECT &rect2  ); //   ?
inline bool   PointInPolygon(const POINT &point, const POINT *const polygon, int size); //   

inline SIZEEX GetScreenSize();

inline RECTEX  ScreenToClient(HWND, const RECT&);
inline POINTEX ScreenToClient(HWND, const POINT&);
inline RECTEX  ClientToScreen(HWND, const RECT&);
inline POINTEX ClientToScreen(HWND, const POINT&);

inline BOOL MoveWindow(HWND, const RECT &rect, BOOL bRepaint = TRUE);
inline BOOL SetWindowPos(HWND hWnd, HWND hWndInsertAfter, const RECT &rect, UINT uFlags);

inline RECTEX GetWindowRect(HWND hWnd);
inline SIZEEX GetWindowSize(HWND hWnd);
inline RECTEX GetClientRect(HWND hWnd);
inline SIZEEX GetClientSize(HWND hWnd);

inline CString  GetClassName     (HWND);
inline WNDPROC  GetWindowProc    (HWND);
inline WNDPROC  SetWindowProc    (HWND, WNDPROC pWndProc);
#ifdef GetWindowStyle // see <WindowsX.h>
   #undef GetWindowStyle
inline DWORD    GetWindowStyle   (HWND); //    'WindowsX.h'
#endif
inline DWORD    SetWindowStyle   (HWND, DWORD lStyle);
inline DWORD    GetWindowStyleEx (HWND); //   GetWindowExStyle  'WindowsX.h'
inline DWORD    SetWindowStyleEx (HWND, DWORD lStyleEx);
inline LONG_PTR GetWindowUserData(HWND);
inline LONG_PTR SetWindowUserData(HWND, LONG_PTR lUserData);

inline POINTEX GetCursorPos();
inline void ShowCursor();
inline void HideCursor();

CString SelectFile(BOOL bOpenDialog, HWND hWndOwner, LPCTSTR szDefSelectedFile = NULL, LPCTSTR szDefExt = NULL, LPCTSTR szFilter = _T("All files (*.*)\0*.*\0\0"), LPCTSTR szTitle = NULL, LPCTSTR szInitialDir = NULL, DWORD dwFlags = OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_LONGNAMES | OFN_PATHMUSTEXIST);
CString SelectFolder(
   HWND hwndOwner  = NULL,                   //    
   LPCTSTR szTitle = _T("Open folder"),      //   
   DWORD dwFlags   = BIF_BROWSEFORCOMPUTER | BIF_DONTGOBELOWDOMAIN | BIF_EDITBOX,
   int nFolder     = /** /CSIDL_DRIVES/**/-1/**/); //  -1 -      
                                             //   - see CSIDL_... (func SHGetSpecialFolderLocation)


LONGLONG GetFileSizeEx (LPCTSTR szFileName); //  
DWORD    GetFileSize   (LPCTSTR szFileName); //  

CString GetFileDir    (LPCTSTR szFullFileName); //         (     )
CString GetFileName   (LPCTSTR szFullFileName); //      
CString GetFileVersion(LPCTSTR szFileName, OUT WORD *pwVerMSHigh=NULL, OUT WORD *pwVerMSLow=NULL, OUT WORD *pwVerLSHigh=NULL, OUT WORD *pwVerLSLow=NULL);
inline BOOL PathExist(LPCTSTR szPath);
inline BOOL FileExist(LPCTSTR szPath);
inline CString GetModuleFileName(HMODULE hModule = NULL); // retrieves the full path and filename for the executable file containing the specified module
inline CString GetModuleDir     (HMODULE hModule); //        (    )

CString GetWindowText(HWND hWnd);

inline BOOL    SetMenuString(HMENU hMenu, UINT uItem, BOOL bByPosition, LPCTSTR szNewText);
inline CString GetMenuString(HMENU hMenu, UINT uItem, BOOL bByPosition);

       CString GetIPAdress();
       CString GetHostName();
inline CString GetComputerName();
inline CString GetUserName();

inline CString GetCurrentDirectory();
inline CString GetSystemDirectory();
inline CString GetWindowsDirectory();
inline CString GetTempPath();
//inline CString GetTempFileName(IN LPCTSTR szFile);

inline CString MIMEType2FileType(LPCTSTR szMIMEType);
inline CString FileType2MIMEType(LPCTSTR szFileType);

inline HBITMAP CreateCompatibleBitmap(HBITMAP, int iWidth, int iHeight);
inline HBITMAP CreateBitmap(int iWidth, int iHeight);  // create compatible bitmap at desktop
inline HBITMAP CreateBitmap(const SIZE &size);         // create compatible bitmap at desktop
inline HBITMAP CreateMono(const SIZE &sizeBmp);        // create monohrome bitmap
       HBITMAP CreateMask(HBITMAP hBmp, COLORREF colorTransparent = CLR_INVALID); // create monohrome bitmap from color bitmap. hBmp     HDC
HBITMAP CreateRotatedBitmap(HBITMAP hBitmap, float angle, COLORREF clrBack = CLR_INVALID /* Pixel(0,0) */);

inline SIZEEX SizeBitmap(HDC hCDC); // only for compatible device context
inline SIZEEX SizeBitmap(HBITMAP hBmp); // hBmp       

inline int rand(int maxDiapason); //     0  maxDiapason,   

CString MemCopyAsHex   (LPCVOID pData, DWORD dwSize, BOOL bUsePrefix = FALSE, LPCTSTR szSeparator = NULL);
CString MemCopyAsString(LPCVOID pData, DWORD dwSize, TCHAR chSeparatorEOL = _T('\n'), BOOL bUnicode = FALSE);

void BeepSpeaker(DWORD dwFreq = 500, DWORD dwDuration = 0x25);

inline CString Format(LPCTSTR szFormat, ...);
#ifndef _UNICODE
   inline CString AnsiToOem(LPCTSTR);
   inline CString OemToAnsi(LPCTSTR);
#endif // _UNICODE
inline CString Replace(IN const CString &str, IN LPCTSTR szOld, IN LPCTSTR szNew);
inline CString Replace(IN const CString &str, IN TCHAR    cOld, IN TCHAR    cNew);

BOOL SerializeRead (IN HANDLE hFile, OUT      CString &str, UINT iMaxLength = 0x3FF);
BOOL SerializeWrite(IN HANDLE hFile, IN const CString &str);

class COSVersion {
private:
   OSVERSIONINFO m_vi;
public:
   COSVersion() {
      m_vi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
      BOOL bRes = ::GetVersionEx(&m_vi);
      if (!bRes) memset(&m_vi,0,sizeof(OSVERSIONINFO));
   }
   const OSVERSIONINFO& Get() const { return m_vi; }
   bool IsLonghorn()  const { return IsVista(); }
   bool IsVista()     const { return ((m_vi.dwPlatformId == VER_PLATFORM_WIN32_NT) && (m_vi.dwMajorVersion == 6) && (m_vi.dwMinorVersion == 0)); }
   bool IsWinXP()     const { return ((m_vi.dwPlatformId == VER_PLATFORM_WIN32_NT) && (m_vi.dwMajorVersion == 5) && (m_vi.dwMinorVersion == 1)); }
   bool IsWin2000()   const { return ((m_vi.dwPlatformId == VER_PLATFORM_WIN32_NT) && (m_vi.dwMajorVersion == 5) && (m_vi.dwMinorVersion == 0)); }
   bool IsWinNT()     const { return ((m_vi.dwPlatformId == VER_PLATFORM_WIN32_NT) && ((m_vi.dwMajorVersion == 4) || (m_vi.dwMajorVersion == 3))/* && (m_vi.dwMinorVersion == 0)*/); }
   bool IsWin9598Me() const { return ((m_vi.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS) && (m_vi.dwMajorVersion == 4)); }
   bool IsWin95()     const { return ((m_vi.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS) && (m_vi.dwMajorVersion == 4) && (m_vi.dwMinorVersion == 0)); }
   bool IsWin98()     const { return ((m_vi.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS) && (m_vi.dwMajorVersion == 4) && (m_vi.dwMinorVersion == 10)); }
   bool IsWinMe()     const { return ((m_vi.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS) && (m_vi.dwMajorVersion == 4) && (m_vi.dwMinorVersion == 90)); }
};

inline SYSTEMTIME GetSystemTime();
inline SYSTEMTIME GetLocalTime();
inline FILETIME   GetSystemTimeAsFileTime();
inline SYSTEMTIME FileTimeToSystemTime(const FILETIME   &FileTime);
inline FILETIME   SystemTimeToFileTime(const SYSTEMTIME &SysTime);
inline FILETIME   FileTimeToLocalFileTime(const FILETIME &FileTime);

inline BOOL BitBlt    (HDC, const RECT&, HDC, const POINT&, DWORD);
inline BOOL BitBlt    (HDC, const RECT&, HDC, /* ={0,0} */  DWORD);
inline BOOL BitBlt    (HDC, const SIZE&, HDC, const POINT&, DWORD);
inline BOOL BitBlt    (HDC, const SIZE&, HDC, /* ={0,0} */  DWORD);
inline BOOL StretchBlt(HDC, const RECT&, HDC, const RECT&,  DWORD);
inline BOOL StretchBlt(HDC, const RECT&, HDC, const SIZE&,  DWORD);
inline BOOL StretchBlt(HDC, const SIZE&, HDC, const SIZE&,  DWORD);
inline BOOL StretchBlt(HDC, const SIZE&, HDC, const RECT&,  DWORD);

//     
// 1.  
//    : -   (destination context)
//              -        
// 2.   ( )
//    : -   (source context)
//                  (HBITMAP)
//              -     / ( )
//                  LeftTop    / (   )
// 3. .
//    : -  c   -
//              -     ( )   LeftTop     (   )
//           -    (    HBITMAP    )
//           -  ,   (   ! )
//              -     ( )
//                  LeftTop    (   )
//                    1.                 2.                         3. .
BOOL StretchBltMasked(HDC hDCDst, RECT const &rcDst, HDC     hDCSrc , RECT  const &rcSrc , HDC hDCMsk, RECT  const &rcMsk);
BOOL BitBltMasked    (HDC hDCDst, RECT const &rcDst, HDC     hDCSrc , POINT const &pLTSrc, HDC hDCMsk, POINT const &pLTMsk);
BOOL StretchBltMasked(HDC hDCDst, RECT const &rcDst, HBITMAP hBmpSrc, RECT  const &rcSrc , COLORREF clrTransparent);
BOOL BitBltMasked    (HDC hDCDst, RECT const &rcDst, HBITMAP hBmpSrc, POINT const &pLTSrc, COLORREF clrTransparent);
BOOL BitBltMasked    (HDC hDCDst, RECT const &rcDst, HDC     hDCSrc , POINT const &pLTSrc, COLORREF clrTransparent);
BOOL StretchBltMasked(HDC hDCDst, RECT const &rcDst, HDC     hDCSrc , RECT  const &rcSrc , POINT const *pPointsMsk, int nCount, RECT  const &rcMsk);
BOOL BitBltMasked    (HDC hDCDst, RECT const &rcDst, HDC     hDCSrc , POINT const &pLTSrc, POINT const *pPointsMsk, int nCount, POINT const &pLTMsk);

class CRegistry {
public:
   // Agreement:
   //
   // HKEY_CURRENT_USER\SOFTWARE\MyProg\szParam = "string"
   // HKEY_CURRENT_USER\SOFTWARE\MyProg\dwParam = 0x000123
   //                                             |______|-- Value
   //                                   |______|------------ ValueName
   //                   |______________|-------------------- SubKey
   // |________________________________|-------------------- Key
   // |________________________________________|------------ KeyName (Key + ValueName)
   //

   // read methods
   static CString GetString(IN HKEY hKey, IN LPCTSTR szValueName);                                           // Return value
   static DWORD   GetDWord (IN HKEY hKey, IN LPCTSTR szValueName);                                           // Return value
   static DWORD   GetBinary(IN HKEY hKey, IN LPCTSTR szValueName, OUT BYTE *pbValue, IN OUT DWORD &cbValue); // Return error code!!!
   // write methods
   static DWORD   SetString(IN HKEY hKey, IN LPCTSTR szValueName, IN LPCTSTR szValue);                       // Return error code
   static DWORD   SetDWord (IN HKEY hKey, IN LPCTSTR szValueName, IN DWORD   dwValue);                       // Return error code
   static DWORD   SetBinary(IN HKEY hKey, IN LPCTSTR szValueName, IN const BYTE *pbValue, IN DWORD cbValue); // Return error code

   // read methods
   static CString GetString(IN LPCTSTR szKeyName);                                               // Return value.         Example - "HKEY_CURRENT_USER\\SOFTWARE\\strParam"
   static DWORD   GetDWord (IN LPCTSTR szKeyName);                                               // Return value.         Example - "HKEY_CURRENT_USER\\SOFTWARE\\dwParam"
   static DWORD   GetBinary(IN LPCTSTR szKeyName, OUT BYTE *pbValue, IN OUT DWORD &dwSizeValue); // Return error code!!!. Example - "HKEY_CURRENT_USER\\SOFTWARE\\bnParam", you byte array for result, size byte array.
   // write methods
   static DWORD   SetString(IN LPCTSTR szKeyName, IN LPCTSTR szValue);                       // Return error code. Example - "HKEY_CURRENT_USER\\SOFTWARE\\strParam", "value"
   static DWORD   SetDWord (IN LPCTSTR szKeyName, IN DWORD   dwValue);                       // Return error code. Example - "HKEY_CURRENT_USER\\SOFTWARE\\dwParam", 123
   static DWORD   SetBinary(IN LPCTSTR szKeyName, IN const BYTE *pbValue, IN DWORD cbValue); // Return error code. Example - "HKEY_CURRENT_USER\\SOFTWARE\\bnParam", you byte array, size byte array.

   // delete methods
   static BOOL DeleteKey  (IN HKEY     hKey, IN LPCTSTR szSubKey);
   static BOOL DeleteKey  (IN LPCTSTR szKey, IN LPCTSTR szSubKey);
   static BOOL DeleteValue(IN HKEY     hKey, IN LPCTSTR szValueName);
   static BOOL DeleteValue(IN LPCTSTR szKeyName);

   // find methods
   typedef BOOL (CALLBACK* SUBKEYENUMPROC   )(IN HKEY hKey, IN LPCTSTR szKey, IN DWORD dwIndex, IN LPCTSTR szSubKey, IN LPVOID lpUserData); // if return FALSE -> stop enumerators
   typedef BOOL (CALLBACK* VALUENAMEENUMPROC)(IN HKEY hKey, IN LPCTSTR szKey, IN DWORD dwIndex, IN LPCTSTR szValueName, IN DWORD dwType, IN LPVOID lpUserData); // if return FALSE -> stop enumerators

   static BOOL    EnumSubKeyName(IN HKEY     hKey, IN SUBKEYENUMPROC lpEnumFunc, IN LPVOID lpUserData);
   static BOOL    EnumSubKeyName(IN LPCTSTR szKey, IN SUBKEYENUMPROC lpEnumFunc, IN LPVOID lpUserData);
   static CString EnumSubKeyName(IN HKEY     hKey, IN DWORD dwIndex);
   static CString EnumSubKeyName(IN LPCTSTR szKey, IN DWORD dwIndex); // example - "HKEY_CURRENT_USER\\SOFTWARE", 1  or  "HKEY_CURRENT_USER\\SOFTWARE\\", 1

   static BOOL    EnumValueName (IN HKEY     hKey, IN VALUENAMEENUMPROC lpEnumFunc, IN LPVOID lpUserData);
   static BOOL    EnumValueName (IN LPCTSTR szKey, IN VALUENAMEENUMPROC lpEnumFunc, IN LPVOID lpUserData);
   static CString EnumValueName (IN HKEY     hKey, IN DWORD dwIndex, OUT DWORD &dwType);
   static CString EnumValueName (IN LPCTSTR szKey, IN DWORD dwIndex, OUT DWORD &dwType); // example - "HKEY_CURRENT_USER\\SOFTWARE", 1  or  "HKEY_CURRENT_USER\\SOFTWARE\\", 1
};

LPCVOID GetResource( //     
   IN HMODULE hModule,
   IN LPCTSTR szResourceType,
   IN LPCTSTR szResourceName,
   OUT DWORD &dwSize
);
LPCVOID GetResource( //     
   IN HMODULE hModule,
   IN LPCTSTR szResourceType,
   IN LPCTSTR szResourceName,
   IN WORD wLanguage,
   OUT DWORD &dwSize
);
BOOL SaveResourceAsFile( //       (      bReplaceFile == TRUE)
   IN HMODULE hModule,
   IN LPCTSTR szFileName,
   IN LPCTSTR szResourceType,
   IN LPCTSTR szResourceName,
   IN BOOL    bReplaceFile
);
BOOL SaveResourceAsFile( //          (      bReplaceFile == TRUE)
   IN HMODULE hModule,
   IN LPCTSTR szFileName,
   IN LPCTSTR szResourceType,
   IN LPCTSTR szResourceName,
   IN WORD    wLanguage,
   IN BOOL    bReplaceFile
);

inline HINSTANCE __stdcall GetInstanceFromAddress(PVOID pEip); //  HINSTANCE ,       ( Alex Fedotov rsdn)
inline HINSTANCE __stdcall GetCurrentInstance();               //  HINSTANCE ,       ( Alex Fedotov rsdn)

inline CString GUID2String(IN REFGUID guid);
       BOOL    String2GUID(IN LPCTSTR szGUID, OUT GUID &guid); // example - {00000000-0000-0000-C000-000000000046} to IID_IUnknown
inline GUID    String2GUID(IN LPCTSTR szGUID); //    {FFFFFFFF-FFFF-FFFF-FFFF-FFFFFFFFFFFF}
inline GUID    CoCreateGuid();

CString ErrorCode2Str(DWORD dwErrCode = ::GetLastError());
CString ErrorCode2Str(IN HMODULE hModule, IN DWORD dwErrCode);
CString ErrorCode2Str(IN LPCTSTR lpModuleName, IN DWORD dwErrCode);
CString WinInetErrorCode2Str(DWORD dwErrCode); // from WinInet.dll

typedef BOOL (CALLBACK* FILEENUMPROC)(IN LPCTSTR szDirName, IN LPCTSTR szFileName  , IN UINT iPos, IN LPVOID lpUserData); // if return FALSE -> stop enumerators
typedef BOOL (CALLBACK* DIRENUMPROC )(IN LPCTSTR szDirName, IN LPCTSTR szSubDirName, IN UINT iPos, IN LPVOID lpUserData); // if return FALSE -> stop enumerators
BOOL EnumFiles (IN LPCTSTR szDirName, IN LPCTSTR szMask, IN FILEENUMPROC lpEnumFunc, IN LPVOID lpUserData); //  
BOOL EnumSubDir(IN LPCTSTR szDirName,                    IN  DIRENUMPROC lpEnumFunc, IN LPVOID lpUserData); //  

inline CString Locale(WORD wIDLanguage, LCTYPE LCType = LOCALE_SLANGUAGE);

inline void alert(LPCTSTR); //  JScript alert'
inline void alert(int);
inline void alert(double);

#include "CommonLib.hpp"

#endif // __FILE__KSERG_COMMON_LIB__
